#include <std_include.hpp>
#include "loader/component_loader.hpp"

#include <utils/hook.hpp>
#include <utils/string.hpp>

namespace fov {
namespace {
void dvar_set_from_string_by_name_from_source(const char* dvar_name,
                                              const char* string,
                                              game::DvarSetSource source) {
  if (utils::string::compare(dvar_name, "cg_fov") ||
      utils::string::compare(dvar_name, "cg_fovScale")) {
    game::Com_Printf(game::CON_CHANNEL_DONT_FILTER,
                     "Not allowing the client to override dvar '%s'\n",
                     dvar_name);
    return;
  }

  game::Dvar_SetFromStringByNameFromSource(dvar_name, string, source);
}
} // namespace

class component final : public component_interface {
public:
  void post_load() override {
    utils::hook(0x5D7818, dvar_set_from_string_by_name_from_source,
                HOOK_CALL)
        .install() // hook*
        ->quick(); // GScr_SetSavedDvar

    utils::hook(0x5CC8D9, dvar_set_from_string_by_name_from_source,
                HOOK_CALL)
        .install() // hook*
        ->quick(); // GScr_SetDvar_Internal
  }
};
} // namespace fov

REGISTER_COMPONENT(fov::component)
